/* Copyright 2012, Unpublished Work of Technologic Systems
 * All Rights Reserved.
 *
 * THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 * PROPRIETARY AND TRADE SECRET INFORMATION OF TECHNOLOGIC SYSTEMS.
 * ACCESS TO THIS WORK IS RESTRICTED TO (I) TECHNOLOGIC SYSTEMS 
 * EMPLOYEES WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE
 * OF THEIR ASSIGNMENTS AND (II) ENTITIES OTHER THAN TECHNOLOGIC
 * SYSTEMS WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.  NO
 * PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED, 
 * DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED, 
 * EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED, ADAPTED
 * IN ANY FORM OR BY ANY MEANS, MANUAL, MECHANICAL, CHEMICAL, 
 * ELECTRICAL, ELECTRONIC, OPTICAL, BIOLOGICAL, OR OTHERWISE WITHOUT
 * THE PRIOR WRITTEN PERMISSION AND CONSENT OF TECHNOLOGIC SYSTEMS.
 * ANY USE OR EXPLOITATION OF THIS WORK WITHOUT THE PRIOR WRITTEN
 * CONSENT OF TECHNOLOGIC SYSTEMS COULD SUBJECT THE PERPETRATOR TO
 * CRIMINAL AND CIVIL LIABILITY.
 */

module ts4300_top(

  dio_pad,
  ext_int1_pad,
  ext_int2_pad,
  ext_resetn_pad,
  en_lcd_3v3_pad,
  en_usb_5v_pad,
  off_bd_resetn_pad,
  red_ledn_pad,
  green_ledn_pad,
  sd_powern_pad,
  sd0_fault_ledn_pad,
  sd1_fault_ledn_pad,
  sd_act_ledn_pad,
  nv_data_pad,
  nv_clk_pad,
  nv_q_pad,
  fpga_holdn_pad,
  cpu_wd_outn_pad,
  bus_waitn_pad,
  fpga_25mhz_pad,
  low_voltn_pad,
  cpu_spi_clk_pad,
  cpu_spi_mosi_pad,
  cpu_spi_miso_pad,
  cpu_spi_csn_pad,
  mux_ad_pad,
  bus_alen_pad,
  bus_dir_pad,
  bus_csn_pad,
  bus_bhen_pad,
  sd0_d0_pad,
  sd0_d1_pad,
  sd0_d2_pad,
  sd0_d3_pad,
  sd0_cmd_pad,
  sd0_clk_pad,
  sd1_d0_pad,
  sd1_d1_pad,
  sd1_d2_pad,
  sd1_d3_pad,
  sd1_cmd_pad,
  sd1_clk_pad,
  uart0_txd_pad,
  uart0_rxd_pad,
  uart1_txd_pad,
  uart1_rxd_pad,
  uart2_txd_pad,
  uart2_rxd_pad,
  uart3_txd_pad,
  uart3_rxd_pad,
  uart4_txd_pad,
  uart4_rxd_pad,
  uart5_txd_pad,
  uart5_rxd_pad,
  cpu_reset_d_pad,
  cpu_reset_clk_pad,
  cpu_32khz_pad,

  ob_spi_clk_pad,
  ob_spi_mosi_pad,
  ob_spi_miso_pad,
  ob_spi_csn_pad,

  nor_spi_clk_pad,
  nor_spi_mosi_pad,
  nor_spi_miso_pad,
  nor_spi_csn_pad,
  flash_wpn_pad,
  flash_holdn_pad,

  pcie_tx_m_pad,
  pcie_tx_p_pad,
  pcie_rx_m_pad,
  pcie_rx_p_pad,
  pcie_100mhz_m_pad,
  pcie_100mhz_p_pad

);

inout [73:0] dio_pad;
inout ext_int1_pad;
inout ext_int2_pad;
inout ext_resetn_pad;
output en_lcd_3v3_pad;
output en_usb_5v_pad;
inout off_bd_resetn_pad;
inout red_ledn_pad;
inout green_ledn_pad;
output sd_powern_pad;
inout sd0_fault_ledn_pad;
inout sd1_fault_ledn_pad;
inout sd_act_ledn_pad;
output nv_data_pad;
output nv_clk_pad;
input nv_q_pad;
inout fpga_holdn_pad;
inout cpu_wd_outn_pad;
inout bus_waitn_pad;
input fpga_25mhz_pad;
input low_voltn_pad;
inout cpu_spi_clk_pad;
inout cpu_spi_mosi_pad;
output cpu_spi_miso_pad;
inout cpu_spi_csn_pad;
inout [15:0] mux_ad_pad;
inout bus_alen_pad;
inout bus_dir_pad;
inout bus_csn_pad;
inout bus_bhen_pad;
inout sd0_d0_pad;
inout sd0_d1_pad;
inout sd0_d2_pad;
inout sd0_d3_pad;
inout sd0_cmd_pad;
output sd0_clk_pad /* synthesis syn_maxfan=1 syn_useioff=1 */;
inout sd1_d0_pad;
inout sd1_d1_pad;
inout sd1_d2_pad;
inout sd1_d3_pad;
inout sd1_cmd_pad;
output sd1_clk_pad /* synthesis syn_maxfan=1 syn_useioff=1 */;
inout uart0_txd_pad;
inout uart0_rxd_pad;
inout uart1_txd_pad;
inout uart1_rxd_pad;
inout uart2_txd_pad;
inout uart2_rxd_pad;
inout uart3_txd_pad;
inout uart3_rxd_pad;
inout uart4_txd_pad;
inout uart4_rxd_pad;
inout uart5_txd_pad;
inout uart5_rxd_pad;
output cpu_reset_d_pad;
output cpu_reset_clk_pad;
output cpu_32khz_pad;

inout ob_spi_clk_pad;
inout ob_spi_mosi_pad;
inout ob_spi_miso_pad;
inout ob_spi_csn_pad;

output nor_spi_clk_pad;
inout nor_spi_mosi_pad;
inout nor_spi_miso_pad;
output nor_spi_csn_pad;
inout flash_wpn_pad;
inout flash_holdn_pad;

output pcie_tx_m_pad;
output pcie_tx_p_pad;
input pcie_rx_m_pad;
input pcie_rx_p_pad;
input pcie_100mhz_m_pad;
input pcie_100mhz_p_pad;

parameter sdcard_opt = 1'b1;
parameter spi_opt = 1'b1;
parameter can_opt = 1'b1;
parameter xuart_opt = 1'b1;
parameter externalbus_opt = 1'b1;
parameter sd_dma = 1'b1;
parameter flash_dma = 1'b1;
parameter can_dma = 1'b0;
parameter uart_dma = 1'b0;
parameter muxbus16_dma = 1'b1;
parameter muxbus8_dma = 1'b1;
parameter dma_channels = { 2'b00, muxbus8_dma, muxbus16_dma, uart_dma,
                           can_dma, flash_dma, sd_dma};

// I am assigning all unused pads up here for completeness.
//assign dio_pad[73:32] = 42'd0;
assign ext_int1_pad = 1'bz;
assign ext_int2_pad = 1'bz;
//assign ext_resetn_pad = 1'b1;
//assign en_lcd_3v3_pad = 1'b1;
//assign en_usb_5v_pad = 1'b1;
//assign off_bd_resetn_pad = 1'b1;
//assign red_ledn_pad = 1'b0;
//assign green_ledn_pad = 1'b0;
//assign sd_powern_pad = 1'b0;
//assign sd0_fault_ledn_pad = 1'b0;
//assign sd1_fault_ledn_pad = 1'b0;
//assign sd_act_ledn_pad = 1'b0;
assign nv_data_pad = 1'b0;
assign nv_clk_pad = 1'b0;
assign fpga_holdn_pad = 1'bz;
assign cpu_wd_outn_pad = 1'bz;
//assign bus_waitn_pad = 1'bz;
assign cpu_spi_clk_pad = 1'bz;
assign cpu_spi_mosi_pad = 1'bz;
assign cpu_spi_miso_pad = 1'b1;
assign cpu_spi_csn_pad = 1'bz;
//assign mux_ad_pad = 16'hzzzz;
//assign bus_alen_pad = 1'bz;
//assign bus_dir_pad = 1'bz;
//assign bus_csn_pad = 1'bz;
//assign bus_bhen_pad = 1'bz;
//assign sd0_d0_pad = 1'bz;
//assign sd0_d1_pad = 1'bz;
//assign sd0_d2_pad = 1'bz;
//assign sd0_d3_pad = 1'bz;
//assign sd0_cmd_pad = 1'bz;
//assign sd0_clk_pad = 1'b1;
//assign sd1_d0_pad = 1'bz;
//assign sd1_d1_pad = 1'bz;
//assign sd1_d2_pad = 1'bz;
//assign sd1_d3_pad = 1'bz;
//assign sd1_cmd_pad = 1'bz;
//assign sd1_clk_pad = 1'b1;
//assign uart0_txd_pad = 1'bz;
//assign uart0_rxd_pad = 1'bz;
//assign uart1_txd_pad = 1'bz;
//assign uart1_rxd_pad = 1'bz;
//assign uart2_txd_pad = 1'bz;
//assign uart2_rxd_pad = 1'bz;
//assign uart3_txd_pad = 1'bz;
//assign uart3_rxd_pad = 1'bz;
//assign uart4_txd_pad = 1'bz;
//assign uart4_rxd_pad = 1'bz;
//assign uart5_txd_pad = 1'bz;
//assign uart5_rxd_pad = 1'bz;
//assign cpu_reset_d_pad = 1'b1;
//assign cpu_reset_clk_pad = 1'b1;
//assign cpu_32khz_pad = 1'bz;

//assign ob_spi_clk_pad = 1'bz;
//assign ob_spi_mosi_pad = 1'bz;
//assign ob_spi_miso_pad = 1'bz;
//assign ob_spi_csn_pad = 1'bz;

/****************************************************************************
 * Boilerplate PLL
 ****************************************************************************/

wire wb_rst, wb_clk, clk_100mhz, rst_100mhz, lock;
assign wb_clk = clk_100mhz;
assign wb_rst = rst_100mhz;

pll1 clkgen1(
  .CLK_IN1(fpga_25mhz_pad),
  .CLK_OUT1(clk_100mhz),
  .RESET(!low_voltn_pad),
  .LOCKED(lock)
);

reg [15:0] rst_100_counter = 16'd0;
reg rstn_100 = 1'b0;
reg lock_100_q;
always @(posedge clk_100mhz) begin
  lock_100_q <= lock;
  if (lock_100_q) rst_100_counter <= rst_100_counter + 1'b1;
  else begin
    rst_100_counter <= 16'd0;
    rstn_100 <= 1'b0;
  end
  if (rst_100_counter[15]) rstn_100 <= 1'b1;
end
assign rst_100mhz = !rstn_100;
assign off_bd_resetn_pad = 1'b1;
assign cpu_reset_clk_pad = 1'b1;
assign cpu_reset_d_pad = 1'b1;

reg [15:0] count_32khz;
reg clk_32khz;
assign cpu_32khz_pad = clk_32khz;
always @ (posedge clk_100mhz or posedge rst_100mhz) begin
  if (rst_100mhz) begin 
    count_32khz = 16'd0;
  end else begin
    count_32khz = count_32khz + 1'b1;
    // 100,000,000 / 32768 = ~3052
    if (count_32khz == 16'd1525) begin
      count_32khz = 16'd0;
      clk_32khz = ~clk_32khz;
    end
  end
end

reg [2:0] count_12mhz; // actually 12.5 MHz
always @(posedge clk_100mhz or posedge rst_100mhz) begin
  if (rst_100mhz) count_12mhz <= 3'd0;
  else count_12mhz <= count_12mhz + 1'b1;
end

/****************************************************************************
 * PCIe Wishbone bridge
 ****************************************************************************/

// This is the main "normal" 32 bit wishbone bus:
wire pciewbm_cyc_o, pciewbm_stb_o, pciewbm_we_o;
wire [31:0] pciewbm_adr_o;
wire [31:0] pciewbm_dat_o;
wire [3:0] pciewbm_sel_o;
reg pciewbm_ack_i;
reg [31:0] pciewbm_dat_i;

// 16 bit cores can be connected using this bus, as long as software emits
// only 16 bit or 8 bit writes
reg [15:0] pciewbm_dat16_o;
reg [31:0] pciewbm_adr16_o;
reg [1:0] pciewbm_sel16_o;
always @(*) begin
  if (pciewbm_sel_o[1:0] == 2'b00) begin //upper word
    pciewbm_dat16_o = pciewbm_dat_o[31:16];
    pciewbm_adr16_o = {pciewbm_adr_o[31:2], 2'b10};
    pciewbm_sel16_o = pciewbm_sel_o[3:2];
  end else begin // lower word
    pciewbm_dat16_o = pciewbm_dat_o[15:0];
    pciewbm_adr16_o = pciewbm_adr_o;
    pciewbm_sel16_o = pciewbm_sel_o[1:0];
  end
end

// 8 bit cores can be connected using this bus, as long as software emits
// only 8 bit writes
reg [7:0] pciewbm_dat8_o;
reg [31:0] pciewbm_adr8_o;
always @(*) begin
  if (pciewbm_sel_o[0]) begin
    pciewbm_dat8_o = pciewbm_dat_o[7:0];
    pciewbm_adr8_o = {pciewbm_adr_o[31:2], 2'b00};
  end else if (pciewbm_sel_o[1]) begin
    pciewbm_dat8_o = pciewbm_dat_o[15:8];
    pciewbm_adr8_o = {pciewbm_adr_o[31:2], 2'b01};
  end else if (pciewbm_sel_o[2]) begin
    pciewbm_dat8_o = pciewbm_dat_o[23:16];
    pciewbm_adr8_o = {pciewbm_adr_o[31:2], 2'b10};
  end else begin
    pciewbm_dat8_o = pciewbm_dat_o[31:24];
    pciewbm_adr8_o = {pciewbm_adr_o[31:2], 2'b11};
  end
end

// DMA buses should normally be connected only to one slave each:
wire dma0wbm_cyc_o, dma0wbm_stb_o, dma0wbm_we_o, dma0wbm_ack_i;
wire [31:0] dma0wbm_adr_o, dma0wbm_dat_o, dma0wbm_dat_i;
wire [3:0] dma0wbm_sel_o;
wire [63:0] dmactl0;
wire [13:0] dmacount0;

wire dma1wbm_cyc_o, dma1wbm_stb_o, dma1wbm_we_o, dma1wbm_ack_i;
wire [31:0] dma1wbm_adr_o, dma1wbm_dat_o, dma1wbm_dat_i;
wire [3:0] dma1wbm_sel_o;
wire [63:0] dmactl1;
wire [13:0] dmacount1;

wire dma2wbm_cyc_o, dma2wbm_stb_o, dma2wbm_we_o, dma2wbm_ack_i;
wire [31:0] dma2wbm_adr_o, dma2wbm_dat_o, dma2wbm_dat_i;
wire [3:0] dma2wbm_sel_o;
wire [63:0] dmactl2;
wire [13:0] dmacount2;

wire dma3wbm_cyc_o, dma3wbm_stb_o, dma3wbm_we_o, dma3wbm_ack_i;
wire [31:0] dma3wbm_adr_o, dma3wbm_dat_o, dma3wbm_dat_i;
wire [3:0] dma3wbm_sel_o;
wire [63:0] dmactl3;
wire [13:0] dmacount3;

wire dma4wbm_cyc_o, dma4wbm_stb_o, dma4wbm_we_o, dma4wbm_ack_i;
wire [31:0] dma4wbm_adr_o, dma4wbm_dat_o, dma4wbm_dat_i;
wire [3:0] dma4wbm_sel_o;
wire [63:0] dmactl4;
wire [13:0] dmacount4;

wire dma5wbm_cyc_o, dma5wbm_stb_o, dma5wbm_we_o, dma5wbm_ack_i;
wire [31:0] dma5wbm_adr_o, dma5wbm_dat_o, dma5wbm_dat_i;
wire [3:0] dma5wbm_sel_o;
wire [63:0] dmactl5;
wire [13:0] dmacount5;

wire dma6wbm_cyc_o, dma6wbm_stb_o, dma6wbm_we_o, dma6wbm_ack_i;
wire [31:0] dma6wbm_adr_o, dma6wbm_dat_o, dma6wbm_dat_i;
wire [3:0] dma6wbm_sel_o;
wire [63:0] dmactl6;
wire [13:0] dmacount6;

wire dma7wbm_cyc_o, dma7wbm_stb_o, dma7wbm_we_o, dma7wbm_ack_i;
wire [31:0] dma7wbm_adr_o, dma7wbm_dat_o, dma7wbm_dat_i;
wire [3:0] dma7wbm_sel_o;
wire [63:0] dmactl7;
wire [13:0] dmacount7;

reg [7:0] fpga_irqs;
wire [7:0] irq_mask;
reg muxbus_irq8, muxbus_irq16;
wire [7:0] dma_irq = {2'b00, muxbus_irq8, muxbus_irq16, 4'b0000};

pcie_wb_bridge pciecore(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk),

  .pcie_rx_p_i(pcie_rx_p_pad),
  .pcie_rx_m_i(pcie_rx_m_pad),
  .pcie_tx_p_o(pcie_tx_p_pad),
  .pcie_tx_m_o(pcie_tx_m_pad),
  .pcie_clk_p_i(pcie_100mhz_p_pad),
  .pcie_clk_m_i(pcie_100mhz_m_pad),

  .wbm_stb_o(pciewbm_stb_o),
  .wbm_cyc_o(pciewbm_cyc_o),
  .wbm_adr_o(pciewbm_adr_o),
  .wbm_sel_o(pciewbm_sel_o),
  .wbm_we_o(pciewbm_we_o),
  .wbm_dat_o(pciewbm_dat_o),
  .wbm_dat_i(pciewbm_dat_i),
  .wbm_ack_i(pciewbm_ack_i),

  .ch0_stb_o(dma0wbm_stb_o),
  .ch0_cyc_o(dma0wbm_cyc_o),
  .ch0_adr_o(dma0wbm_adr_o),
  .ch0_sel_o(dma0wbm_sel_o),
  .ch0_we_o(dma0wbm_we_o),
  .ch0_dat_o(dma0wbm_dat_o),
  .ch0_dat_i(dma0wbm_dat_i),
  .ch0_ack_i(dma0wbm_ack_i),
  .dma_ctl0_i(dmactl0),
  .count0_o(dmacount0),

  .ch1_stb_o(dma1wbm_stb_o),
  .ch1_cyc_o(dma1wbm_cyc_o),
  .ch1_adr_o(dma1wbm_adr_o),
  .ch1_sel_o(dma1wbm_sel_o),
  .ch1_we_o(dma1wbm_we_o),
  .ch1_dat_o(dma1wbm_dat_o),
  .ch1_dat_i(dma1wbm_dat_i),
  .ch1_ack_i(dma1wbm_ack_i),
  .dma_ctl1_i(dmactl1),
  .count1_o(dmacount1),

  .ch2_stb_o(dma2wbm_stb_o),
  .ch2_cyc_o(dma2wbm_cyc_o),
  .ch2_adr_o(dma2wbm_adr_o),
  .ch2_sel_o(dma2wbm_sel_o),
  .ch2_we_o(dma2wbm_we_o),
  .ch2_dat_o(dma2wbm_dat_o),
  .ch2_dat_i(dma2wbm_dat_i),
  .ch2_ack_i(dma2wbm_ack_i),
  .dma_ctl2_i(dmactl2),
  .count2_o(dmacount2),

  .ch3_stb_o(dma3wbm_stb_o),
  .ch3_cyc_o(dma3wbm_cyc_o),
  .ch3_adr_o(dma3wbm_adr_o),
  .ch3_sel_o(dma3wbm_sel_o),
  .ch3_we_o(dma3wbm_we_o),
  .ch3_dat_o(dma3wbm_dat_o),
  .ch3_dat_i(dma3wbm_dat_i),
  .ch3_ack_i(dma3wbm_ack_i),
  .dma_ctl3_i(dmactl3),
  .count3_o(dmacount3),

  .ch4_stb_o(dma4wbm_stb_o),
  .ch4_cyc_o(dma4wbm_cyc_o),
  .ch4_adr_o(dma4wbm_adr_o),
  .ch4_sel_o(dma4wbm_sel_o),
  .ch4_we_o(dma4wbm_we_o),
  .ch4_dat_o(dma4wbm_dat_o),
  .ch4_dat_i(dma4wbm_dat_i),
  .ch4_ack_i(dma4wbm_ack_i),
  .dma_ctl4_i(dmactl4),
  .count4_o(dmacount4),

  .ch5_stb_o(dma5wbm_stb_o),
  .ch5_cyc_o(dma5wbm_cyc_o),
  .ch5_adr_o(dma5wbm_adr_o),
  .ch5_sel_o(dma5wbm_sel_o),
  .ch5_we_o(dma5wbm_we_o),
  .ch5_dat_o(dma5wbm_dat_o),
  .ch5_dat_i(dma5wbm_dat_i),
  .ch5_ack_i(dma5wbm_ack_i),
  .dma_ctl5_i(dmactl5),
  .count5_o(dmacount5),

  .ch6_stb_o(dma6wbm_stb_o),
  .ch6_cyc_o(dma6wbm_cyc_o),
  .ch6_adr_o(dma6wbm_adr_o),
  .ch6_sel_o(dma6wbm_sel_o),
  .ch6_we_o(dma6wbm_we_o),
  .ch6_dat_o(dma6wbm_dat_o),
  .ch6_dat_i(dma6wbm_dat_i),
  .ch6_ack_i(dma6wbm_ack_i),
  .dma_ctl6_i(dmactl6),
  .count6_o(dmacount6),

  .ch7_stb_o(dma7wbm_stb_o),
  .ch7_cyc_o(dma7wbm_cyc_o),
  .ch7_adr_o(dma7wbm_adr_o),
  .ch7_sel_o(dma7wbm_sel_o),
  .ch7_we_o(dma7wbm_we_o),
  .ch7_dat_o(dma7wbm_dat_o),
  .ch7_dat_i(dma7wbm_dat_i),
  .ch7_ack_i(dma7wbm_ack_i),
  .dma_ctl7_i(dmactl7),
  .count7_o(dmacount7),

  .dma_irq_i(dma_irq),
  .irq_i(fpga_irqs & ~irq_mask),
  .dma_disable_i(~dma_channels)
);

/****************************************************************************
 * Syscon
 ****************************************************************************/

wire [107:0] dio_oe, dio, dio_in;
wire [15:0] bus_config;

wire reboot;
assign ext_resetn_pad = reboot ? 1'b0 : 1'bz;

wire [31:0] control_reg;
assign green_ledn_pad = control_reg[0] ? 1'b0 : 1'bz;
assign red_ledn_pad = control_reg[1] ? 1'b0 : 1'bz;
assign sd0_fault_ledn_pad = control_reg[2] ? 1'b0 : 1'bz;
assign sd1_fault_ledn_pad = control_reg[3] ? 1'b0 : 1'bz;
wire [5:0] en_txen = control_reg[9:4];
wire en_bbclk = control_reg[10];
wire en_can = control_reg[11];
wire en_can2 = control_reg[12];
assign en_lcd_3v3_pad = control_reg[13];
assign en_usb_5v_pad = control_reg[14];
always @(*) begin
  muxbus_irq8 = 0;
  muxbus_irq16 = 0;
  if (control_reg[16]) muxbus_irq8 = dio_in[0];
  if (control_reg[17]) muxbus_irq8 = dio_in[1];
  if (control_reg[18]) muxbus_irq8 = dio_in[2];
  if (control_reg[19]) muxbus_irq16 = dio_in[0];
  if (control_reg[20]) muxbus_irq16 = dio_in[1];
  if (control_reg[21]) muxbus_irq16 = dio_in[2];
end
wire tsadc_special = control_reg[22];
/* control_reg[31] = force reset
 * control_reg[30] = enable reset switch
 * those are implemented inside syscon.v
 * control_reg bits 29:23 and 15 are reserved at this time.
 */

reg scwbs_en;
wire [31:0] scwbs_dat_o;
wire scwbs_ack_o;

syscon sysconcore(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb_cyc_i(pciewbm_cyc_o && scwbs_en),
  .wb_stb_i(pciewbm_stb_o && scwbs_en),
  .wb_we_i(pciewbm_we_o),
  .wb_adr_i(pciewbm_adr_o),
  .wb_dat_i(pciewbm_dat_o),
  .wb_sel_i(pciewbm_sel_o),
  .wb_dat_o(scwbs_dat_o),
  .wb_ack_o(scwbs_ack_o),

  .dio_i(dio_in),
  .dio_oe_o(dio_oe),
  .dio_o(dio),
  .control_reg_o(control_reg),
  .bus_config_o(bus_config),
  .irq_mask_o(irq_mask),

  .mode2_i(mode2),
  .reboot_o(reboot)

);

/****************************************************************************
 * Blockrams for DMA bandwidth testing
 ****************************************************************************/

/*
wb_ram_4kbyte testram0(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma0wbm_cyc_o),
  .wb1_stb_i(dma0wbm_stb_o),
  .wb1_we_i(dma0wbm_we_o),
  .wb1_adr_i(dma0wbm_adr_o),
  .wb1_dat_i(dma0wbm_dat_o),
  .wb1_sel_i(dma0wbm_sel_o),
  .wb1_dat_o(dma0wbm_dat_i),
  .wb1_ack_o(dma0wbm_ack_i)
);

wb_ram_4kbyte testram1(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma1wbm_cyc_o),
  .wb1_stb_i(dma1wbm_stb_o),
  .wb1_we_i(dma1wbm_we_o),
  .wb1_adr_i(dma1wbm_adr_o),
  .wb1_dat_i(dma1wbm_dat_o),
  .wb1_sel_i(dma1wbm_sel_o),
  .wb1_dat_o(dma1wbm_dat_i),
  .wb1_ack_o(dma1wbm_ack_i)
);

wb_ram_4kbyte testram2(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma2wbm_cyc_o),
  .wb1_stb_i(dma2wbm_stb_o),
  .wb1_we_i(dma2wbm_we_o),
  .wb1_adr_i(dma2wbm_adr_o),
  .wb1_dat_i(dma2wbm_dat_o),
  .wb1_sel_i(dma2wbm_sel_o),
  .wb1_dat_o(dma2wbm_dat_i),
  .wb1_ack_o(dma2wbm_ack_i)
);

wb_ram_4kbyte testram3(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma3wbm_cyc_o),
  .wb1_stb_i(dma3wbm_stb_o),
  .wb1_we_i(dma3wbm_we_o),
  .wb1_adr_i(dma3wbm_adr_o),
  .wb1_dat_i(dma3wbm_dat_o),
  .wb1_sel_i(dma3wbm_sel_o),
  .wb1_dat_o(dma3wbm_dat_i),
  .wb1_ack_o(dma3wbm_ack_i)
);

wb_ram_4kbyte testram4(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma4wbm_cyc_o),
  .wb1_stb_i(dma4wbm_stb_o),
  .wb1_we_i(dma4wbm_we_o),
  .wb1_adr_i(dma4wbm_adr_o),
  .wb1_dat_i(dma4wbm_dat_o),
  .wb1_sel_i(dma4wbm_sel_o),
  .wb1_dat_o(dma4wbm_dat_i),
  .wb1_ack_o(dma4wbm_ack_i)
);

wb_ram_4kbyte testram5(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma5wbm_cyc_o),
  .wb1_stb_i(dma5wbm_stb_o),
  .wb1_we_i(dma5wbm_we_o),
  .wb1_adr_i(dma5wbm_adr_o),
  .wb1_dat_i(dma5wbm_dat_o),
  .wb1_sel_i(dma5wbm_sel_o),
  .wb1_dat_o(dma5wbm_dat_i),
  .wb1_ack_o(dma5wbm_ack_i)
);

wb_ram_4kbyte testram6(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma6wbm_cyc_o),
  .wb1_stb_i(dma6wbm_stb_o),
  .wb1_we_i(dma6wbm_we_o),
  .wb1_adr_i(dma6wbm_adr_o),
  .wb1_dat_i(dma6wbm_dat_o),
  .wb1_sel_i(dma6wbm_sel_o),
  .wb1_dat_o(dma6wbm_dat_i),
  .wb1_ack_o(dma6wbm_ack_i)
);

wb_ram_4kbyte testram7(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(dma7wbm_cyc_o),
  .wb1_stb_i(dma7wbm_stb_o),
  .wb1_we_i(dma7wbm_we_o),
  .wb1_adr_i(dma7wbm_adr_o),
  .wb1_dat_i(dma7wbm_dat_o),
  .wb1_sel_i(dma7wbm_sel_o),
  .wb1_dat_o(dma7wbm_dat_i),
  .wb1_ack_o(dma7wbm_ack_i)
);
*/

/****************************************************************************
 * Register block for DMA control registers
 ****************************************************************************/

reg dmawbs_en;
wire [31:0] dmawbs_dat_o;
wire dmawbs_ack_o;

wb_reg_block regblock1(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb_adr_i(pciewbm_adr_o),
  .wb_cyc_i(pciewbm_cyc_o && dmawbs_en),
  .wb_stb_i(pciewbm_stb_o && dmawbs_en),
  .wb_dat_o(dmawbs_dat_o),
  .wb_we_i(pciewbm_we_o),
  .wb_dat_i(pciewbm_dat_o),
  .wb_ack_o(dmawbs_ack_o),
  .wb_sel_i(pciewbm_sel_o),

  .reg0_i(dmactl0[31:0]),
  .reg0_o(dmactl0[31:0]),
  .reg1_i({dmacount0, dmactl0[49:32]}),
  .reg1_o(dmactl0[63:32]),
  .reg2_i(dmactl1[31:0]),
  .reg2_o(dmactl1[31:0]),
  .reg3_i({dmacount1, dmactl1[49:32]}),
  .reg3_o(dmactl1[63:32]),
  .reg4_i(dmactl2[31:0]),
  .reg4_o(dmactl2[31:0]),
  .reg5_i({dmacount2, dmactl2[49:32]}),
  .reg5_o(dmactl2[63:32]),
  .reg6_i(dmactl3[31:0]),
  .reg6_o(dmactl3[31:0]),
  .reg7_i({dmacount3, dmactl3[49:32]}),
  .reg7_o(dmactl3[63:32]),
  .reg8_i(dmactl4[31:0]),
  .reg8_o(dmactl4[31:0]),
  .reg9_i({dmacount4, dmactl4[49:32]}),
  .reg9_o(dmactl4[63:32]),
  .reg10_i(dmactl5[31:0]),
  .reg10_o(dmactl5[31:0]),
  .reg11_i({dmacount5, dmactl5[49:32]}),
  .reg11_o(dmactl5[63:32]),
  .reg12_i(dmactl6[31:0]),
  .reg12_o(dmactl6[31:0]),
  .reg13_i({dmacount6, dmactl6[49:32]}),
  .reg13_o(dmactl6[63:32]),
  .reg14_i(dmactl7[31:0]),
  .reg14_o(dmactl7[31:0]),
  .reg15_i({dmacount7, dmactl7[49:32]}),
  .reg15_o(dmactl7[63:32])
);

/****************************************************************************
 * SD card logic
 ****************************************************************************/
reg sdwbs_en;
wire [31:0] sdwbs_dat_o;
wire sdwbs_ack_o;
wire [2:0] sd_lun;
wire sd_cmd_o, sd_cmd_oe;
reg sd_cmd_i;
wire [3:0] sd_dat_o, sd_dat_oe;
reg [3:0] sd_dat_i;
wire [7:0] sd_clk;
assign sd0_clk_pad = sd_clk[0];
assign sd1_clk_pad = sd_clk[1];
wire sd_busy, sd_power;
assign sd_act_ledn_pad = sd_busy ? 1'b0 : 1'bz;
assign sd_powern_pad = !sd_power;

assign sd0_cmd_pad = (sd_cmd_oe && (sd_lun == 3'd0)) ? sd_cmd_o : 1'bz;
assign sd1_cmd_pad = (sd_cmd_oe && (sd_lun == 3'd1)) ? sd_cmd_o : 1'bz;
assign sd0_d0_pad = (sd_dat_oe[0] && (sd_lun == 3'd0)) ? sd_dat_o[0] : 1'bz;
assign sd0_d1_pad = (sd_dat_oe[1] && (sd_lun == 3'd0)) ? sd_dat_o[1] : 1'bz;
assign sd0_d2_pad = (sd_dat_oe[2] && (sd_lun == 3'd0)) ? sd_dat_o[2] : 1'bz;
assign sd0_d3_pad = (sd_dat_oe[3] && (sd_lun == 3'd0)) ? sd_dat_o[3] : 1'bz;
assign sd1_d0_pad = (sd_dat_oe[0] && (sd_lun == 3'd1)) ? sd_dat_o[0] : 1'bz;
assign sd1_d1_pad = (sd_dat_oe[1] && (sd_lun == 3'd1)) ? sd_dat_o[1] : 1'bz;
assign sd1_d2_pad = (sd_dat_oe[2] && (sd_lun == 3'd1)) ? sd_dat_o[2] : 1'bz;
assign sd1_d3_pad = (sd_dat_oe[3] && (sd_lun == 3'd1)) ? sd_dat_o[3] : 1'bz;
always @(*) begin
  sd_dat_i = 4'hf;
  if (sd_lun == 3'd0) 
    sd_dat_i = {sd0_d3_pad, sd0_d2_pad, sd0_d1_pad, sd0_d0_pad};
  if (sd_lun == 3'd1) 
    sd_dat_i = {sd1_d3_pad, sd1_d2_pad, sd1_d1_pad, sd1_d0_pad};
  sd_cmd_i = 1'b1;
  if (sd_lun == 3'd0) sd_cmd_i = sd0_cmd_pad;
  if (sd_lun == 3'd1) sd_cmd_i = sd1_cmd_pad;
end

ts_sdcore sdcardcore(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & sdcard_opt),

  .wb1_adr_i(pciewbm_adr_o),
  .wb1_cyc_i(pciewbm_cyc_o && sdwbs_en),
  .wb1_stb_i(pciewbm_stb_o && sdwbs_en),
  .wb1_dat_o(sdwbs_dat_o),
  .wb1_we_i(pciewbm_we_o),
  .wb1_dat_i(pciewbm_dat_o),
  .wb1_ack_o(sdwbs_ack_o),
  .wb1_sel_i(pciewbm_sel_o),
  .wb1_bte_i(2'b00),
  .wb1_cti_i(3'b000),

  .wb2_cyc_i(dma0wbm_cyc_o),
  .wb2_stb_i(dma0wbm_stb_o),
  .wb2_we_i(dma0wbm_we_o),
  .wb2_adr_i(dma0wbm_adr_o),
  .wb2_dat_i(dma0wbm_dat_o),
  .wb2_sel_i(dma0wbm_sel_o),
  .wb2_dat_o(dma0wbm_dat_i),
  .wb2_ack_o(dma0wbm_ack_i),
  .wb2_bte_i(2'b00),
  .wb2_cti_i(3'b000),

  .wb3_cyc_i(1'b0),
  .wb3_stb_i(1'b0),
  .wb3_we_i(1'b0),
  .wb3_adr_i(32'd0),
  .wb3_dat_i(32'd0),
  .wb3_sel_i(4'hf),
  .wb3_bte_i(2'b00),
  .wb3_cti_i(3'b000),

  .wb4_cyc_i(1'b0),
  .wb4_stb_i(1'b0),
  .wb4_we_i(1'b0),
  .wb4_adr_i(32'd0),
  .wb4_dat_i(32'd0),
  .wb4_sel_i(4'hf),
  .wb4_bte_i(2'b00),
  .wb4_cti_i(3'b000),

  .sd_cmd_i(sd_cmd_i),
  .sd_cmd_o(sd_cmd_o),
  .sd_cmd_oe_o(sd_cmd_oe),
  .sd_dat_i(sd_dat_i),
  .sd_dat_o(sd_dat_o),
  .sd_dat_oe_o(sd_dat_oe),
  .sd_clk_o(sd_clk),
 
  .sd_wprot_i(8'b00000000),
  .sd_detect_i(8'b00000011),
  .sd_power_o(sd_power),
  .sd_busy_o(sd_busy),
  .sd_selected_lun_o(sd_lun)
);

/****************************************************************************
 * SPI controller for NOR flash
 ****************************************************************************/
reg spiwbs_en;
wire [15:0] spiwbs_dat16_o;
wire [31:0] spiwbs_dat_o = {spiwbs_dat16_o, spiwbs_dat16_o};
wire spiwbs_ack_o;

wire spiwbm_cyc_o, spiwbm_stb_o, spiwbm_we_o, spiwbm_ack_i;
wire [15:0] spiwbm_adr_o, spiwbm_dat_o, spiwbm_dat_i;
wire [1:0] spiwbm_sel_o;

// SPI core-specific streaming addresses:
assign spiwbm_adr_o = spiwbm_we_o ? 32'h00000308 : 32'h0000030a;

wb_32to16_adapter spi_adapter(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & spi_opt),

  .wb_cyc_i(dma1wbm_cyc_o),
  .wb_stb_i(dma1wbm_stb_o),
  .wb_we_i(dma1wbm_we_o),
  .wb_adr_i(dma1wbm_adr_o),
  .wb_dat_i(dma1wbm_dat_o),
  .wb_sel_i(dma1wbm_sel_o),
  .wb_dat_o(dma1wbm_dat_i),
  .wb_ack_o(dma1wbm_ack_i),

  .wbm_stb_o(spiwbm_stb_o),
  .wbm_cyc_o(spiwbm_cyc_o),
  //.wbm_adr_o(spiwbm_adr_o),
  .wbm_sel_o(spiwbm_sel_o),
  .wbm_we_o(spiwbm_we_o),
  .wbm_dat_o(spiwbm_dat_o),
  .wbm_dat_i(spiwbm_dat_i),
  .wbm_ack_i(spiwbm_ack_i),

  .incr_i(1'b0)
);

wire spi_sck;
wire [3:0] spi_di, spi_do, spi_oe, spi_do_dly;
assign nor_spi_mosi_pad = spi_oe[0] ? spi_do[0] : 1'bz;
assign nor_spi_miso_pad = spi_oe[1] ? spi_do[1] : 1'bz;
assign flash_wpn_pad = spi_oe[2] ? spi_do[2] : 1'bz;
assign flash_holdn_pad = spi_oe[3] ? spi_do[3] : 1'bz;
assign spi_di[0] = nor_spi_mosi_pad;
assign spi_di[1] = nor_spi_miso_pad;
assign spi_di[2] = flash_wpn_pad;
assign spi_di[3] = flash_holdn_pad;

wb_spi2 spicore(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & spi_opt),

  .wb1_cyc_i(pciewbm_cyc_o && spiwbs_en),
  .wb1_stb_i(pciewbm_stb_o && spiwbs_en),
  .wb1_dat_o(spiwbs_dat16_o),
  .wb1_dat_i(pciewbm_dat16_o),
  .wb1_adr_i(pciewbm_adr16_o),
  .wb1_we_i(pciewbm_we_o),
  .wb1_ack_o(spiwbs_ack_o),
  .wb1_sel_i(pciewbm_sel16_o),

  .wb2_cyc_i(spiwbm_cyc_o),
  .wb2_stb_i(spiwbm_stb_o),
  .wb2_dat_o(spiwbm_dat_i),
  .wb2_dat_i(spiwbm_dat_o),
  .wb2_adr_i(spiwbm_adr_o),
  .wb2_we_i(spiwbm_we_o),
  .wb2_ack_o(spiwbm_ack_i),
  .wb2_sel_i(spiwbm_sel_o),

  .sck_o(nor_spi_clk_pad),
  .d_o(spi_do),
  .d_oe_o(spi_oe),
  .d_i(spi_di),
  .csn_o(nor_spi_csn_pad)
);

/****************************************************************************
 * SJA1000C compatible CAN controller
 ****************************************************************************/

reg [4:0] seq_24mhz;
reg clk_24mhz;
reg can_enable_q;
wire can_enable;
always @(posedge clk_100mhz or posedge rst_100mhz) begin
  if (rst_100mhz) begin
    clk_24mhz <= 1'b1;
    seq_24mhz <= 5'd0;
    can_enable_q <= 1'b0;
  end else begin
    can_enable_q <= can_enable;
    if (can_enable_q) begin
      seq_24mhz <= seq_24mhz + 1'b1;
      case (seq_24mhz)
      1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21: clk_24mhz <= !clk_24mhz;
      24: begin
        clk_24mhz <= !clk_24mhz;
        seq_24mhz <= 5'd0;
      end
      endcase
    end else seq_24mhz <= 5'd0;
  end
end

wire candma_cyc_o, candma_stb_o, candma_we_o, candma_ack_i;
wire [7:0] candma_dat_o, candma_dat_i;
wire [31:0] candma_adr_o;

wb_32to8_adapter can_adapter(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & can_opt),

  .wb_cyc_i(dma2wbm_cyc_o),
  .wb_stb_i(dma2wbm_stb_o),
  .wb_we_i(dma2wbm_we_o),
  .wb_adr_i(dma2wbm_adr_o),
  .wb_dat_i(dma2wbm_dat_o),
  .wb_sel_i(dma2wbm_sel_o),
  .wb_dat_o(dma2wbm_dat_i),
  .wb_ack_o(dma2wbm_ack_i),

  .wbm_stb_o(candma_stb_o),
  .wbm_cyc_o(candma_cyc_o),
  .wbm_adr_o(candma_adr_o),
  .wbm_we_o(candma_we_o),
  .wbm_dat_o(candma_dat_o),
  .wbm_dat_i(candma_dat_i),
  .wbm_ack_i(candma_ack_i),

  .incr_i(1'b0)
);

reg canwbs_en;
wire [7:0] canwbs_dat8_o;
wire [31:0] canwbs_dat_o = {4{canwbs_dat8_o}};
wire canwbs_ack_o;

wire canwbm_cyc_o, canwbm_stb_o, canwbm_we_o, canwbm_ack_i;
wire [7:0] canwbm_dat_o, canwbm_dat_i;
wire [31:0] canwbm_adr_o;

// A little easier to put this arbiter here than to hack up can_top with it.
wb_arbiter can_arbiter(
  .wb_clk_i(wb_clk),

  .wbowner_dat_o(canwbm_dat_o),
  .wbowner_dat_i(canwbm_dat_i),
  .wbowner_adr_o(canwbm_adr_o),
  .wbowner_cyc_o(canwbm_cyc_o),
  .wbowner_stb_o(canwbm_stb_o),
  .wbowner_we_o(canwbm_we_o),
  .wbowner_ack_i(canwbm_ack_i),

  .wb1_cyc_i(pciewbm_cyc_o && canwbs_en),
  .wb1_stb_i(pciewbm_stb_o && canwbs_en),
  .wb1_dat_o(canwbs_dat8_o),
  .wb1_dat_i(pciewbm_dat8_o),
  .wb1_adr_i(pciewbm_adr8_o),
  .wb1_we_i(pciewbm_we_o),
  .wb1_ack_o(canwbs_ack_o),

  .wb2_adr_i(candma_adr_o),
  .wb2_dat_i(candma_dat_o),
  .wb2_dat_o(candma_dat_i),
  .wb2_cyc_i(candma_cyc_o),
  .wb2_stb_i(candma_stb_o),
  .wb2_we_i(candma_we_o),
  .wb2_ack_o(candma_ack_i)
);

wire can_tx, can_irqn;

can_top cancore(
  .wb_clk_i(wb_clk && can_opt),
  .wb_rst_i(wb_rst),
  .wb_cyc_i(canwbm_cyc_o),
  .wb_stb_i(canwbm_stb_o),
  .wb_we_i(canwbm_we_o),
  .wb_dat_i(canwbm_dat_o),
  .wb_dat_o(canwbm_dat_i),
  .wb_adr_i(canwbm_adr_o[7:0]),
  .wb_ack_o(canwbm_ack_i),

  .clk_i(clk_24mhz && can_opt),
  .rx_i(dio_pad[16]),
  .tx_o(can_tx),
  .irq_on(can_irqn)
  //.bus_off_on(can_enable)
);

/****************************************************************************
 * TS-XUART super uarts
 ****************************************************************************/
reg xuwbs_en;
wire [15:0] xuartwbs_dat16_o;
wire [31:0] xuartwbs_dat_o = {xuartwbs_dat16_o, xuartwbs_dat16_o};
wire xuartwbs_ack_o;

wire uartwbm_cyc_o, uartwbm_stb_o, uartwbm_we_o, uartwbm_ack_i;
wire [31:0] uartwbm_adr_o;
wire [15:0] uartwbm_dat_o;
wire [31:0] uart_dat32;
wire [15:0] uartwbm_dat_i = uartwbm_adr_o[1] ?
                            uart_dat32[31:16] : uart_dat32[15:0];
wire [3:0] uartwbm_sel_o = uartwbm_adr_o[1] ? 4'b1100 : 4'b0011;
reg [7:0] xuart_rx;
wire [7:0] xuart_active;
wire [7:0] xuart_cts = 8'hff;
wire [7:0] xuart_txen, xuart_tx;

reg [7:0] xuart_txen_q, xuart_tx_q;
reg [7:0] xuart_rx_q, xuart_cts_q;
always @(posedge wb_clk or posedge wb_rst) begin
  if (wb_rst) begin
    xuart_rx_q <= 8'hff;
    xuart_cts_q <= 8'hff;
    xuart_tx_q <= 8'hff;
    xuart_txen_q <= 8'hff;
  end else begin
    xuart_rx_q <= xuart_rx;
    xuart_cts_q <= xuart_cts;
    xuart_tx_q <= xuart_tx;
    xuart_txen_q <= xuart_txen;
  end
end

ts_xuart tsxuartcore(
  .wb_clk_i(wb_clk & xuart_opt),
  .wb_rst_i(wb_rst),

  .wbm_cyc_o(uartwbm_cyc_o),
  .wbm_stb_o(uartwbm_stb_o),
  .wbm_we_o(uartwbm_we_o),
  .wbm_dat_o(uartwbm_dat_o),
  .wbm_adr_o(uartwbm_adr_o),
  .wbm_ack_i(uartwbm_ack_i),
  .wbm_dat_i(uartwbm_dat_i),

  .wbs_cyc_i(pciewbm_cyc_o && xuwbs_en),
  .wbs_stb_i(pciewbm_stb_o && xuwbs_en),
  .wbs_dat_o(xuartwbs_dat16_o),
  .wbs_dat_i(pciewbm_dat16_o),
  .wbs_adr_i(pciewbm_adr16_o),
  .wbs_we_i(pciewbm_we_o),
  .wbs_ack_o(xuartwbs_ack_o),

  .baudclk_i(clk_100mhz),
  .cts_i(xuart_cts_q),
  .rx_i(xuart_rx_q),
  .tx_o(xuart_tx),
  .txen_o(xuart_txen),
  .active_o(xuart_active),
  .irq_o(xuart_irq),
  //.uart_disable_i(8'h80)
  .uart_disable_i(8'hc0)
);

/****************************************************************************
 * 16KB Block RAM
 ****************************************************************************/

wire buf3wbm_cyc_o, buf3wbm_stb_o, buf3wbm_we_o, buf3wbm_ack_i;
wire [31:0] buf3wbm_adr_o, buf3wbm_dat_o, buf3wbm_dat_i;
wire [3:0] buf3wbm_sel_o;

wb_buf uartdmabuf(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wbs_cyc_i(dma3wbm_cyc_o),
  .wbs_stb_i(dma3wbm_stb_o),
  .wbs_we_i(dma3wbm_we_o),
  .wbs_adr_i(dma3wbm_adr_o),
  .wbs_dat_o(dma3wbm_dat_i),
  .wbs_dat_i(dma3wbm_dat_o),
  .wbs_ack_o(dma3wbm_ack_i),
  .wbs_sel_i(dma3wbm_sel_o),

  .wbm_stb_o(buf3wbm_stb_o),
  .wbm_cyc_o(buf3wbm_cyc_o),
  .wbm_adr_o(buf3wbm_adr_o),
  .wbm_sel_o(buf3wbm_sel_o),
  .wbm_we_o(buf3wbm_we_o),
  .wbm_dat_o(buf3wbm_dat_o),
  .wbm_dat_i(buf3wbm_dat_i),
  .wbm_ack_i(buf3wbm_ack_i)
);

reg brwbs_en;
wire [31:0] brwbs_dat_o;
wire brwbs_ack_o;

blockram_16kbyte sramcore(
  .wb_clk_i(wb_clk),
  .wb_rst_i(wb_rst),

  .wb4_cyc_i(uartwbm_cyc_o),
  .wb4_stb_i(uartwbm_stb_o),
  .wb4_we_i(uartwbm_we_o),
  .wb4_dat_i({uartwbm_dat_o, uartwbm_dat_o}),
  .wb4_adr_i({uartwbm_adr_o[31:2], 2'b00}),
  .wb4_ack_o(uartwbm_ack_i),
  .wb4_dat_o(uart_dat32),
  .wb4_sel_i(uartwbm_sel_o),

  .wb2_cyc_i(buf3wbm_cyc_o),
  .wb2_stb_i(buf3wbm_stb_o),
  .wb2_we_i(buf3wbm_we_o),
  .wb2_adr_i(buf3wbm_adr_o),
  .wb2_dat_o(buf3wbm_dat_i),
  .wb2_dat_i(buf3wbm_dat_o),
  .wb2_ack_o(buf3wbm_ack_i),
  .wb2_sel_i(buf3wbm_sel_o),

  // We could remove pciewbm access and use DMA only
  .wb3_cyc_i(pciewbm_cyc_o && brwbs_en),
  .wb3_stb_i(pciewbm_stb_o && brwbs_en),
  .wb3_we_i(pciewbm_we_o),
  .wb3_adr_i(pciewbm_adr_o),
  .wb3_dat_o(brwbs_dat_o),
  .wb3_dat_i(pciewbm_dat_o),
  .wb3_ack_o(brwbs_ack_o),
  .wb3_sel_i(pciewbm_sel_o)
);

/****************************************************************************
 * MUXBUS
 ****************************************************************************/

wire bus16wbm_cyc_o, bus16wbm_stb_o, bus16wbm_we_o, bus16wbm_ack_i;
wire [31:0] bus16wbm_adr_o;
wire [15:0] bus16wbm_dat_o;
wire [15:0] bus16wbm_dat_i;
wire [1:0] bus16wbm_sel_o;

wire bus8wbm_cyc_o, bus8wbm_stb_o, bus8wbm_we_o, bus8wbm_ack_i;
wire [31:0] bus8wbm_adr_o;
wire [7:0] bus8wbm_dat_o;
reg [7:0] bus8wbm_dat_i;

wb_32to16_adapter muxbus16_adapter(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & externalbus_opt),

  .wb_cyc_i(dma4wbm_cyc_o),
  .wb_stb_i(dma4wbm_stb_o),
  .wb_we_i(dma4wbm_we_o),
  .wb_adr_i(dma4wbm_adr_o),
  .wb_dat_i(dma4wbm_dat_o),
  .wb_sel_i(dma4wbm_sel_o),
  .wb_dat_o(dma4wbm_dat_i),
  .wb_ack_o(dma4wbm_ack_i),

  .wbm_stb_o(bus16wbm_stb_o),
  .wbm_cyc_o(bus16wbm_cyc_o),
  .wbm_adr_o(bus16wbm_adr_o),
  .wbm_sel_o(bus16wbm_sel_o),
  .wbm_we_o(bus16wbm_we_o),
  .wbm_dat_o(bus16wbm_dat_o),
  .wbm_dat_i(bus16wbm_dat_i),
  .wbm_ack_i(bus16wbm_ack_i),

  .incr_i(dmactl4[49])
);

wire [1:0] muxbus_phase;

wb_32to8_adapter muxbus8_adapter(
  .wb_rst_i(wb_rst),
  .wb_clk_i(wb_clk & externalbus_opt),

  .wb_cyc_i(dma5wbm_cyc_o),
  .wb_stb_i(dma5wbm_stb_o),
  .wb_we_i(dma5wbm_we_o),
  .wb_adr_i(dma5wbm_adr_o),
  .wb_dat_i(dma5wbm_dat_o),
  .wb_sel_i(dma5wbm_sel_o),
  .wb_dat_o(dma5wbm_dat_i),
  .wb_ack_o(dma5wbm_ack_i),

  .wbm_stb_o(bus8wbm_stb_o),
  .wbm_cyc_o(bus8wbm_cyc_o),
  .wbm_adr_o(bus8wbm_adr_o),
  .wbm_we_o(bus8wbm_we_o),
  .wbm_dat_o(bus8wbm_dat_o),
  .wbm_dat_i(bus8wbm_dat_i),
  .wbm_ack_i(bus8wbm_ack_i),

  .incr_i(dmactl5[49]),
  .phase_o(muxbus_phase)
);

reg muxbus_8bit;
wire [1:0] muxbus_owner;
/* This comment is necessary because I just can't think of good names for 
 * these wires and I am trying to make this understandable.
 * bus16wbm_* is for DMA on the regular 16 bit muxbus.
 * bus8wbm_* is an 8 bit bus for DMA on the 8 bit muxbus.  However, the 8 bit
 * muxbus is accessed over a 16 bit bus.  muxbuswbm_* is then a 16 bit bus for
 * 8 bit transactions, where the select is always 2'b10 or 2'b01.
 *
 * tsadc_special is a signal that puts the 8 bit DMA muxbus in a special mode
 * that is only needed for the TS-ADC16 and TS-ADC24 in which it streams data
 * using alternating reads between two adjacent 8 bit addresses.
 */
wire [16:0] muxbuswbm_dat_o = {bus8wbm_dat_o, bus8wbm_dat_o};
wire [16:0] muxbuswbm_dat_i;
reg [1:0] muxbuswbm_sel_o;

always @(*) begin
  case (muxbus_owner)
    2'b00: muxbus_8bit = pciewbm_adr_o[16];
    2'b01: muxbus_8bit = 1'b0;
    2'b10: muxbus_8bit = 1'b1;
    default: muxbus_8bit = 1'b0;
  endcase

  if (tsadc_special) begin
    muxbuswbm_sel_o = muxbus_phase[0] ? 2'b10 : 2'b01;
    bus8wbm_dat_i = muxbus_phase[0] ? muxbuswbm_dat_i[15:8] :
                                       muxbuswbm_dat_i[7:0];
  end else begin
    muxbuswbm_sel_o = bus8wbm_adr_o[0] ? 2'b10 : 2'b01;
    bus8wbm_dat_i = bus8wbm_adr_o[0] ? muxbuswbm_dat_i[15:8] :
                                       muxbuswbm_dat_i[7:0];
  end
end

reg buswbs_en;
wire [15:0] buswbs16_dat_o;
wire [31:0] buswbs_dat_o = {buswbs16_dat_o, buswbs16_dat_o};
wire buswbs_ack_o;
wire [15:0] bus_dat;
wire bus_dat_oe;
wire bus_dir, bus_csn, bus_bhen;
isamuxbus_bridge externalbus(
  .wb_clk_i(wb_clk & externalbus_opt),
  .wb_rst_i(wb_rst),

  .wb1_cyc_i(pciewbm_cyc_o && buswbs_en),
  .wb1_stb_i(pciewbm_stb_o && buswbs_en),
  .wb1_we_i(pciewbm_we_o),
  .wb1_adr_i(pciewbm_adr16_o[15:0]), // 16 bits of bus space
  .wb1_dat_i(pciewbm_dat16_o),
  .wb1_sel_i(pciewbm_sel16_o),
  .wb1_dat_o(buswbs16_dat_o),
  .wb1_ack_o(buswbs_ack_o),

  .wb2_stb_i(bus16wbm_stb_o),
  .wb2_cyc_i(bus16wbm_cyc_o),
  .wb2_adr_i(bus16wbm_adr_o),
  .wb2_sel_i(bus16wbm_sel_o),
  .wb2_we_i(bus16wbm_we_o),
  .wb2_dat_i(bus16wbm_dat_o),
  .wb2_dat_o(bus16wbm_dat_i),
  .wb2_ack_o(bus16wbm_ack_i),

  .wb3_stb_i(bus8wbm_stb_o),
  .wb3_cyc_i(bus8wbm_cyc_o),
  .wb3_adr_i({bus8wbm_adr_o[15:1], 1'b0}),
  .wb3_sel_i(muxbuswbm_sel_o),
  .wb3_we_i(bus8wbm_we_o),
  .wb3_dat_i(muxbuswbm_dat_o),
  .wb3_dat_o(muxbuswbm_dat_i),
  .wb3_ack_o(bus8wbm_ack_i),

  .bus_config_i(bus_config),
  .cs_8bit_i(muxbus_8bit),
  .csn_o(bus_csn),
  .dir_o(bus_dir),
  .ale_o(bus_ale),
  .bhen_o(bus_bhen),
  .waitn_i(bus_wait_padn),
  .mux_i(mux_ad_pad),
  .mux_o(bus_dat),
  .mux_oe_o(bus_dat_oe),

  .arbiter_owner_o(muxbus_owner)
);


/****************************************************************************
 * DIO multiplexing
 ****************************************************************************/

/* All the following count as DIO:
 * dio_pad[73:0] minus 38 to 40 = 71 pads
 * muxbus = 21 pads
 * uarts = 12 pads
 * spi = 4 pads
 *
 * Total 108 pads.  I will just go ahead and use up 12 32 bit registers.
 */
reg [107:0] dio_reg, pad_o, pad_oe;

assign dio_pad[37:0] = dio_reg[37:0];
// DIO 38/39/40 no longer exist.
assign dio_pad[73:41] = dio_reg[73:41];
assign mux_ad_pad[15:0] = dio_reg[89:74];
assign bus_waitn_pad = dio_reg[90];
assign bus_bhen_pad = dio_reg[91];
assign bus_csn_pad = dio_reg[92];
assign bus_dir_pad = dio_reg[93];
assign bus_alen_pad = dio_reg[94];
// might as well start a new register for UART pads
assign uart0_txd_pad = dio_reg[96];
assign uart0_rxd_pad = dio_reg[97];
assign uart1_txd_pad = dio_reg[98];
assign uart1_rxd_pad = dio_reg[99];
assign uart2_txd_pad = dio_reg[100];
assign uart2_rxd_pad = dio_reg[101];
assign uart3_txd_pad = dio_reg[102];
assign uart3_rxd_pad = dio_reg[103];
assign uart4_txd_pad = dio_reg[104];
assign uart4_rxd_pad = dio_reg[105];
assign uart5_txd_pad = dio_reg[106];
assign uart5_rxd_pad = dio_reg[107];
// Using SPI pads to fill in random spots:
assign ob_spi_csn_pad = dio_reg[95];
assign ob_spi_mosi_pad = dio_reg[38];
assign ob_spi_miso_pad = dio_reg[39];
assign ob_spi_clk_pad = dio_reg[40];

assign dio_in[107:96] = {
  uart5_rxd_pad,
  uart5_txd_pad,
  uart4_rxd_pad,
  uart4_txd_pad,
  uart3_rxd_pad,
  uart3_txd_pad,
  uart2_rxd_pad,
  uart2_txd_pad,
  uart1_rxd_pad,
  uart1_txd_pad,
  uart0_rxd_pad,
  uart0_txd_pad
};
assign dio_in[89:74] = mux_ad_pad;
assign dio_in[94:90] = {
  bus_alen_pad,
  bus_dir_pad,
  bus_csn_pad,
  bus_bhen_pad,
  bus_waitn_pad
};
assign dio_in[95] = ob_spi_csn_pad;
assign dio_in[40] = ob_spi_clk_pad;
assign dio_in[39] = ob_spi_miso_pad;
assign dio_in[38] = ob_spi_mosi_pad;
assign dio_in[73:41] = dio_pad[73:41];
assign dio_in[37:0] = dio_pad[37:0];

integer i;

always @(*) begin
  for (i = 0; i <= 107; i = i + 1) begin
    dio_reg[i] = pad_oe[i] ? pad_o[i] : 1'bz;
  end
end

always @(*) begin
  pad_o = dio;
  pad_oe = dio_oe;
  fpga_irqs = 8'd0;

  /* Primary CAN port overrides dio 15 and 16 */
  if (en_can) begin
    pad_o[15] = can_tx;
    pad_oe[16:15] = 2'b01;
    //fpga_irqs[1] = !can_irqn;
  end

  /* external bus overrides DIO 22-42 */
  if (bus_config[0]) begin // config bit 0 = bus enable
    pad_o[91] = bus_bhen;
    pad_o[92] = bus_csn;
    pad_o[93] = bus_dir;
    pad_o[94] = !bus_ale;
    pad_oe[94:90] = 5'b11110;
    pad_o[89:74] = bus_dat;
    pad_oe[89:74] = bus_dat_oe ? 16'hffff : 16'h0000;
    fpga_irqs[5:3] = dio_pad[2:0];
    //pad_oe[2:0] = 3'b000;
  end

  /* WARNING: UART numbering is all off by one. */
  //if (xuart_active[7:0] != 8'h00) fpga_irqs[0] = xuart_irq;
  xuart_rx = 8'hff;

  xuart_rx[0] = uart0_rxd_pad;
  if (xuart_active[0]) begin
    pad_o[96] = xuart_tx_q[0];
    pad_oe[97:96] = 2'b01;
    if (en_txen[0]) begin
      pad_o[12] = xuart_txen_q[0];
      pad_oe[12] = 1'b1;
    end
  end

  xuart_rx[1] = uart1_rxd_pad;
  if (xuart_active[1]) begin
    pad_o[98] = xuart_tx_q[1];
    pad_oe[99:98] = 2'b01;
    if (en_txen[1]) begin
      pad_o[8] = xuart_txen_q[1];
      pad_oe[8] = 1'b1;
    end
  end

  xuart_rx[2] = uart2_rxd_pad;
  if (xuart_active[2]) begin
    pad_o[100] = xuart_tx_q[2];
    pad_oe[101:100] = 2'b01;
    if (en_txen[2]) begin
      pad_o[10] = xuart_txen_q[2];
      pad_oe[10] = 1'b1;
    end
  end

  xuart_rx[3] = uart3_rxd_pad;
  if (xuart_active[3]) begin
    pad_o[102] = xuart_tx_q[3];
    pad_oe[103:102] = 2'b01;
    if (en_txen[3]) begin
      pad_o[13] = xuart_txen_q[3];
      pad_oe[13] = 1'b1;
    end
  end

  xuart_rx[4] = uart4_rxd_pad;
  if (xuart_active[4]) begin
    pad_o[104] = xuart_tx_q[4];
    pad_oe[105:104] = 2'b01;
    if (en_txen[4]) begin
      pad_o[14] = xuart_txen_q[4];
      pad_oe[14] = 1'b1;
    end
  end

  xuart_rx[5] = uart5_rxd_pad;
  if (xuart_active[5]) begin
    pad_o[106] = xuart_tx_q[5];
    pad_oe[107:106] = 2'b01;
    if (en_txen[5]) begin
      pad_o[7] = xuart_txen_q[5];
      pad_oe[7] = 1'b1;
    end
  end

  xuart_rx[6] = dio_pad[13];

  if (en_bbclk) begin
    pad_o[3] = count_12mhz[2];
    pad_oe[3] = 1'b1;
  end

end


/****************************************************************************
 * Address decode
 ****************************************************************************/

/* Start Address     Core
 * -------------     ----
 * 0x00000000        Syscon
 * 0x00000100        SD card
 * 0x00000200        DMA control registers
 * 0x00000300        SPI (flash)
 * 0x00000400        XUART control registers
 * 0x00000500        CAN
 * 0x00010000        Blockram
 * 0x00020000        16 bit MUXBUS
 * 0x00030000        8 bit MUXBUS
 */

always @(*) begin
  scwbs_en = 1'b0;
  sdwbs_en = 1'b0;
  dmawbs_en = 1'b0;
  spiwbs_en = 1'b0;
  xuwbs_en = 1'b0;
  canwbs_en = 1'b0;
  brwbs_en = 1'b0;
  buswbs_en = 1'b0;

  pciewbm_dat_i = 32'd0;
  pciewbm_ack_i = 1'b1;

  if (pciewbm_adr_o[19:16] == 4'd3) buswbs_en = 1'b1;
  else if (pciewbm_adr_o[19:16] == 4'd2) buswbs_en = 1'b1;
  else if (pciewbm_adr_o[19:16] == 4'd1) brwbs_en = 1'b1;
  else if (pciewbm_adr_o[19:16] == 4'd0) begin
    case (pciewbm_adr_o[11:8])
      4'h0: scwbs_en = 1'b1;
      4'h1: sdwbs_en = 1'b1;
      4'h2: dmawbs_en = 1'b1;
      4'h3: spiwbs_en = 1'b1;
      4'h4: xuwbs_en = 1'b1;
      4'h5: canwbs_en = 1'b1;
    endcase
  end

  if (scwbs_en) pciewbm_dat_i = scwbs_dat_o;
  if (scwbs_en) pciewbm_ack_i = scwbs_ack_o;

  if (sdwbs_en) pciewbm_dat_i = sdwbs_dat_o;
  if (sdwbs_en) pciewbm_ack_i = sdwbs_ack_o;

  if (dmawbs_en) pciewbm_dat_i = dmawbs_dat_o;
  if (dmawbs_en) pciewbm_ack_i = dmawbs_ack_o;

  if (spiwbs_en) pciewbm_dat_i = spiwbs_dat_o;
  if (spiwbs_en) pciewbm_ack_i = spiwbs_ack_o;

  if (xuwbs_en) pciewbm_dat_i = xuartwbs_dat_o;
  if (xuwbs_en) pciewbm_ack_i = xuartwbs_ack_o;

  if (canwbs_en) pciewbm_dat_i = canwbs_dat_o;
  if (canwbs_en) pciewbm_ack_i = canwbs_ack_o;

  if (brwbs_en) pciewbm_dat_i = brwbs_dat_o;
  if (brwbs_en) pciewbm_ack_i = brwbs_ack_o;

  if (buswbs_en) pciewbm_dat_i = buswbs_dat_o;
  if (buswbs_en) pciewbm_ack_i = buswbs_ack_o;
end

endmodule
